function [U,P1,P2,step]=FEM_Newton_fixed_residual(P1prev,P2prev,U)
global STEMAelastic B W 
global global tolerance tolerance_Newton maximum_Newton_step;
global condestA N

[help,feste2DKnoten]=find(B);

disp('evaluating right hand side Phi');
[Phi,plasticelements,P1,P2]=evaluate_Phi(U,P1prev,P2prev);

residualvector=Phi; residualvector(feste2DKnoten)=[];
residual=sqrt(residualvector'*(residualvector));
fprintf('residual Phi: %f \n',residual);

if residual==0
   further=0;
else
   further=1;
end

tolerance_reached=0;
step=0;
residualold=residual;

while (further==1) & (step<=maximum_Newton_step) 
			 if isempty(find(plasticelements))	%elasticity only
             disp('substituting elastic matrix DPhi')          
             %global matrix - set up
             stabilization=max(max(STEMAelastic));
             A=[STEMAelastic, stabilization*B';stabilization*B,...
                   sparse(size(B,1),size(B,1))];
         else %plasticity!!
             disp('evaluating plastic matrix DPHi')
             DPhi=evaluate_DPhi_plastic(U,P1prev,P2prev,plasticelements);
                        
             %global matrix - set up
             stabilization=max(max(DPhi));
             A=[DPhi,stabilization*B';stabilization*B,sparse(size(B,1),...
                   size(B,1))];
          end 
          
          %condestA=[condestA condest(A)];
          %N=[N size(STEMAelastic,2)];
                    
          b=[Phi; stabilization*W];
             
          % Newton iteration
          disp('solving linear system')
          solution=A\b;
          Udeltavector=solution(1:size(STEMAelastic,1));
          lambda=solution(size(STEMAelastic,1)+1:end);
          Udelta=matrix2form(Udeltavector);
                    
			  U=U-Udelta;
                    
          disp('evaluating right hand side Phi');
          [Phi,plasticelements,P1,P2]=evaluate_Phi(U,P1prev,P2prev);
          
          %residualvector=Phi; residualvector(feste2DKnoten)=[];
          %residual=sqrt(residualvector'*(residualvector));
          residual=norm(stabilization*B'*lambda-Phi);
          fprintf('residual Phi: %f \n',residual);
          
          if residual<tolerance_Newton
             further=0;
          end
          
          residualold=residual;
          step=step+1;
end
       if step==maximum_Newton_step
          disp('maximum number of Newton steps exceeded!!!');
          pause
       end
       
       
       