function [U,P1,P2]=FEM_Newton_fixed_steps(P1prev,P2prev,U,number_of_steps)
global STEMAelastic B W
[help,feste2DKnoten]=find(B);

disp('evaluating right hand side Phi');

[Phi,plasticelements,P1,P2]=evaluate_Phi(U,P1prev,P2prev);
          
residualvector=Phi; residualvector(feste2DKnoten)=[];
residual=sqrt(residualvector'*(residualvector));
fprintf('residual Phi: %f \n',residual);

stabilization=max(max(STEMAelastic));
for i=1:number_of_steps
   if isempty(find(plasticelements,1))	%elasticity only
      disp('substituting elastic matrix DPhi');
      %global matrix - set up
      A=[STEMAelastic, stabilization*B';stabilization*B,...
                   sparse(size(B,1),size(B,1))];
               
   else %plasticity!!
      disp('evaluating plastic matrix DPHi');
      DPhi=evaluate_DPhi_plastic(U,P1prev,P2prev,plasticelements);
      %global matrix - set up
      stabilization=max(max(DPhi));
      %stabilization=1;
      A=[DPhi,stabilization*B';stabilization*B,sparse(size(B,1),...
                   size(B,1))];
   end 
   %condestA=[condestA condest(A)];
   %N=[N size(STEMAelastic,2)];
   b=[Phi; stabilization*W];
   % one Newton iteration
   disp('solving linear system');
   solution=A\b;
   lambda=solution(size(STEMAelastic,1)+1:end);
   Udeltavector=solution(1:size(STEMAelastic,1));
   Udelta=matrix2form(Udeltavector);
   U=U-Udelta;
   [Phi,plasticelements,P1,P2]=evaluate_Phi(U,P1prev,P2prev);
   %residualvector=Phi;residualvector(feste2DKnoten)=[];
   %residual=sqrt(residualvector'*(residualvector));
   residual=norm(stabilization*B'*lambda-Phi);
   fprintf('residual Phi: %f \n',residual);

end