function [U,P1,P2,step]=FEM_Newton_three_stages(P1prev,P2prev,U)
global STEMAelastic B W 
global tolerance maximum_Newton_step;
global condestA N

[help,feste2DKnoten]=find(B);

disp('evaluating right hand side Phi');
[Phi,plasticelements,P1,P2]=evaluate_Phi(U,P1prev,P2prev);

residualvector=Phi; residualvector(feste2DKnoten)=[];
residual=sqrt(residualvector'*(residualvector));
fprintf('residual Phi: %f \n',residual);

if residual==0
   further=0;
else
   further=1;
end

tolerance_reached=0;
step=0;
residualold=residual;

while (further==1) & (step<=maximum_Newton_step) 
   if isempty(find(plasticelements))	%elasticity only
      disp('substituting elastic matrix DPhi');
      %global matrix - set up
      stabilization=max(max(STEMAelastic));
      A=[STEMAelastic, stabilization*B';stabilization*B,...
                   sparse(size(B,1),size(B,1))];
   else %plasticity!!
      disp('evaluating plastic matrix DPHi');
      DPhi=evaluate_DPhi_plastic(U,P1prev,P2prev,plasticelements);
      %global matrix - set up
      stabilization=max(max(DPhi));
      A=[DPhi,stabilization*B';stabilization*B,sparse(size(B,1),...
                   size(B,1))];
   end
   %condestA=[condestA condest(A)];
   %N=[N size(STEMAelastic,2)];
   b=[Phi; stabilization*W];
   % one Newton iteration
   disp('solving linear system');
   solution=A\b;
   lambda=solution(size(STEMAelastic,1)+1:end);
   Udeltavector=solution(1:size(STEMAelastic,1));
   Udelta=matrix2form(Udeltavector);
   U=U-Udelta;
   disp('evaluating right hand side Phi');
   [Phi,plasticelements,P1,P2]=evaluate_Phi(U,P1prev,P2prev);
   %residualvector=Phi; residualvector(feste2DKnoten)=[];
   %residual=sqrt(residualvector'*(residualvector));
   residual=norm(stabilization*B'*lambda-Phi);
   %fprintf('residual =%10.8f \n',residual);
   fprintf('residual Phi: %f \n',residual);
   
   if residual<=tolerance
      tolerance_reached=1;
   end
   if (tolerance_reached==1) & (residual>residualold)
      further=0;
   end
   residualold=residual;
   step=step+1;
end

if step==maximum_Newton_step
   display('maximum number of Newton steps exceeded!!!');
   pause
end      