function [Elemente, Kantenlaengen, Kantennr, Kanten] = NetzInfo(Elemente, Koordinaten, ...
    Dirchlet, Neumann)
% Netzspezifische Information, die zur Zeitersparnis vorher bestimmt werden
global verbosity

lshift = [2,3,1];
AnzahlAussenkanten = size(Dirchlet,1)+size(Neumann,1);

% Umnummerierung, so dass die 1. Kante eines Elements die laengste Kante
% ist; (aH, April '98)
Kantenlaengen = reshape(sqrt(sum((Koordinaten(Elemente(:,[2,3,1]),:) - ...
    Koordinaten(Elemente,:)).^2,2)),size(Elemente));
[lm,off] = max(Kantenlaengen,[],2);
ind = sub2ind( size(Elemente), (1:size(Elemente,1))'*[1,1,1], ...
    rem(ones(size(Elemente,1),1)*(-1:1)+off*[1,1,1],3)+1);
Elemente = Elemente(ind);
Kantenlaengen = Kantenlaengen(ind);
clear llm off ind

% Folgendes liefert Kantennr=sparse(size(Koordinaten,1),size(Koordinaten,1))
% und full-Matrix Kanten mit size(Kanten) = AnzahlderKanten,4 und 
% zeilemweisen Eintraegen [Ecke1, Ecke2, Element1, Element2], wobei 
% Element2 = 0, falls Randkante und Ecke1, Ecke2 ist positiv orientiertes 
% Randstueck von Element1

Kantennr = sparse(size(Koordinaten,1),size(Koordinaten,1));
Kanten = zeros(ceil((size(Elemente,1)*3+AnzahlAussenkanten)/2),4);
cnt=0;
for j = 1:size(Elemente,1)
  for k = 1:3
    if ~Kantennr(Elemente(j,k),Elemente(j,lshift(k)))
      cnt=cnt+1;
      Kanten(cnt,:) = [Elemente(j,k), Elemente(j,lshift(k)), j, 0];
      Kantennr(Elemente(j,k),Elemente(j,lshift(k))) = cnt;
      Kantennr(Elemente(j,lshift(k)),Elemente(j,k)) = cnt;
    else
      Kanten(Kantennr(Elemente(j,k),Elemente(j,lshift(k))), 4) = j;
    end;
  end;
end;
Kanten = Kanten(find(Kanten(:,1)),:);
