function [Koordinaten,NeueElemente,Dirichlet,Neumann]= ...
  RefineElements(Koordinaten,Elemente,Dirichlet,Neumann,Kantenlaengen,...
                                       Kantennr,Kanten,markedEdges,NumbNewElts)
% Verfeinerung gemaess der Eintraege in markedEdges
% 1. Fall
%    nnz(find(markedEdges(j,:)))==3 ->
%       uniforme Verfeinerung von T_j
% 2. Fall
%    nnz(find(markedEdges(j,:)))==2 ->
%       erzeuge 2 neue Knoten; verbinde die beiden neuen Knoten;
%       verbinde neuen Knoten auf laengster Seite mit gegenueber-
%       liegendem alten Knoten
% 3.Fall
%    nnz(find(markedEdges(j,:)))==1 ->
%       erzeuge neuen Knoten; verbinde neuen Knoten mit gegenueber-
%       liegendem alten Knoten

 oldsize = size(Koordinaten,1);
 lshift = [2,3,1];
 NeueElemente = zeros(NumbNewElts,3);
 MarkKnoten = sparse(size(Koordinaten,1),size(Koordinaten,1));
 cnt = 0; Kcnt = size(Koordinaten,1);
 Koordinaten = [Koordinaten; zeros(nnz(markedEdges),2)];
 for j = 1:size(Elemente,1)
   clear NeuKnoten;
   RefineEdge = find(markedEdges(j,:))';
   for k = 1:size(RefineEdge,1)
     Nachbar = sum( Kanten(Kantennr(Elemente(j,RefineEdge(k)), ...
	   Elemente(j,lshift(RefineEdge(k)))),3:4)) -j;
     if Nachbar & Nachbar<j
       NeuKnoten(k) = MarkKnoten(Elemente(j,lshift(RefineEdge(k))), ...
	   Elemente(j,RefineEdge(k)));
     else
       Mitte = (Koordinaten(Elemente(j,RefineEdge(k)),:) + ...
	     Koordinaten(Elemente(j,lshift(RefineEdge(k))),:))/2;
       Kcnt = Kcnt + 1;
       Koordinaten(Kcnt,:) = Mitte;
       NeuKnoten(k) = Kcnt;
       if Nachbar>j
         MarkKnoten(Elemente(j,RefineEdge(k)), ...
	     Elemente(j,lshift(RefineEdge(k)))) = Kcnt;
       else                                     % Knoten auf einer Aussenkante
         MarkKnoten(Elemente(j,RefineEdge(k)), ...
	     Elemente(j,lshift(RefineEdge(k)))) = -Kcnt;
       end
     end
   end
   if size(RefineEdge,1) == 3
     locNeueElemente = [NeuKnoten(lshift); 
       [Elemente(j,1) NeuKnoten(1) NeuKnoten(3)]; 
       [NeuKnoten(1) Elemente(j,2) NeuKnoten(2)];
       [NeuKnoten(3) NeuKnoten(2) Elemente(j,3)]];
   elseif size(RefineEdge,1) == 2
     NKlangeKante = find(RefineEdge == 1);
     NKkurzeKante = find(RefineEdge ~= 1);
     kurzeKante = RefineEdge(NKkurzeKante);
     freieKante = find(markedEdges(j,:)==0);
     locNeueElemente = [[NeuKnoten(NKlangeKante), Elemente(j,freieKante), ...
	     Elemente(j,lshift(freieKante))];
       [NeuKnoten(NKkurzeKante), ...
	     NeuKnoten(NKlangeKante),Elemente(j,kurzeKante)];
       [NeuKnoten(NKkurzeKante), Elemente(j,lshift(kurzeKante)), ...
	     NeuKnoten(NKlangeKante),]];
   elseif size(RefineEdge,1) == 1
     locNeueElemente = [[NeuKnoten Elemente(j,[2,3])];
       [NeuKnoten Elemente(j,[3,1])]];
   else
     locNeueElemente = Elemente(j,:);
   end
   NeueElemente(cnt+1:cnt+size(locNeueElemente,1),:) = locNeueElemente;
   cnt = cnt + size(locNeueElemente,1);
 end

% Dirichlet und Neumann anpassen
 [Elter1,Elter2] = find(MarkKnoten<0);
 for k=1:size(Elter1,1)
   DirichletKante = find(Dirichlet(:,1)==Elter1(k));
   if DirichletKante
     Dirichlet = [Dirichlet(1:DirichletKante-1,:);
       Elter1(k) -MarkKnoten(Elter1(k),Elter2(k));
       -MarkKnoten(Elter1(k),Elter2(k)) Elter2(k);
       Dirichlet(DirichletKante+1:size(Dirichlet,1),:)];
   end
   if Neumann
     NeumannKante =  find(Neumann(:,1)==Elter1(k));
     if NeumannKante
       Neumann = [Neumann(1:NeumannKante-1,:);
       Elter1(k) -MarkKnoten(Elter1(k),Elter2(k));
       -MarkKnoten(Elter1(k),Elter2(k)) Elter2(k);
       Neumann(NeumannKante+1:size(Neumann,1),:)];
     end
   end
 end
		 
% Kcnt ist die wahre Anzahl der neuen Knoten
Koordinaten = Koordinaten(1:Kcnt,:);

 

