function DPhi=evaluate_DPhi_plastic(U,P1prev,P2prev,plasticelements)
global STEMAelastic Koordinaten Elemente Rglobal Areaglobal

DPhi=STEMAelastic;
for j=1:size(Elemente,1);
   if plasticelements(j)>0
      %assignment of real indices
      I=2*Elemente(j,[1 1 2 2 3 3])-[1,0,1,0,1,0];
      P1prevlocal=P1prev(j,:);
      P2prevlocal=P2prev(j,:);
	   Koordinatenlocal=Koordinaten(Elemente(j,:),:);
      Ulocal=U(Elemente(j,:),:);
      Rlocal=Rglobal(:,:,j);
      Arealocal=Areaglobal(j);

      for i=1:6
         Uvectorlocal=vectorform(Ulocal);
         %setting up the increment for the approximation of DPhi
         epsilon=sqrt(eps)*max(1,abs(Uvectorlocal(i)));
         Upluslocal=Uvectorlocal; 
         Uminuslocal=Uvectorlocal;
         Upluslocal(i)=Upluslocal(i)+epsilon;
         Uminuslocal(i)=Uminuslocal(i)-epsilon;
         Upluslocal=matrix2form(Upluslocal);
         Uminuslocal=matrix2form(Uminuslocal);
   
         [P1pluslocal,P2pluslocal]=evaluate_P_on_element(Rlocal,...
                                 Upluslocal,P1prevlocal,P2prevlocal);
         [P1minuslocal,P2minuslocal]=evaluate_P_on_element(Rlocal,...
                                 Uminuslocal,P1prevlocal,P2prevlocal);

         %approximation of the derivation by the difference
         STEMA3Plastic(i,:)=integral_plastic(Rlocal,Arealocal,...
         (P1pluslocal+P2pluslocal-P1minuslocal-P2minuslocal)/2/epsilon);
      end
      DPhi(I,I)=DPhi(I,I)-STEMA3Plastic';
   end
end      