function evaluate_U_exact(number_of_refinements,Newtonsteps)
global last_uniform_refinements;  %minimal value=1

declaration_of_variables
cd MATRICES
load coarse_solution;  %only structure, not solution
cd ..

Elemente=Elemente_coarse;
Koordinaten=Koordinaten_coarse;
Dirichlet=Dirichlet_coarse;
Neumann=Neumann_coarse;

time=t(counter);

Uprev=zeros(size(Koordinaten,1),2); %defined on every node
P1prev=zeros(size(Elemente,1),2); %defined on every element - constant
P2prev=zeros(size(Elemente,1),2); %defined on every element - constant

U=Uprev;   %initial approximation for Newton method

for i=0:(number_of_refinements-1)
  mesh_preparation; %gets mesh ready - STEMAelastic + maske and others
  incorporate_Dirichlet;
  evaluate_fv(time);
  evaluate_gv(time);
  
  if strcmp(problem,'Lshape')
    for j=1:size(Dirichlet,1)
      U(Dirichlet(j,1),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,1),:));
      U(Dirichlet(j,2),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,2),:));
    end
  end
     
  disp('Number of elements');
  disp(size(Elemente,1));
  
  if i>=(number_of_refinements-last_uniform_refinements+1)
        global theta
     thetaold=theta;
     theta=0;
     [U,P1,P2]=FEM_Newton_fixed_steps(P1prev,P2prev,U,1);
     theta=thetaold;
  else
      [U,P1,P2]=FEM_Newton_fixed_steps(P1prev,P2prev,U,Newtonsteps);
  end
   
  cd MATRICES
      save(strcat('U_',num2str(i)),'U');
      save(strcat('P1_',num2str(i)),'P1');
      save(strcat('P2_',num2str(i)),'P2');
      global Elemente Koordinaten Dirichlet Neumann
      save(strcat('mesh_',num2str(i)),'Elemente','Koordinaten',...
                  'Neumann','Dirichlet');
  cd ..
         
  if ~isempty(Neumann)
      NKV = Koordinaten(Neumann(:,2),:)- Koordinaten(Neumann(:,1),:);
      NKV = NKV./[sqrt(sum(NKV.*NKV,2)),sqrt(sum(NKV.*NKV,2))]; 
      % Neumann-Kanten % Vektoren, normiert
      NNV = [NKV(:,2),-NKV(:,1)];  % Neumann-Kanten Normalenvektoren
  else
      NKV=[]; NNV=[];
  end
  [Kantennr,Elemente]=GeneriereKantennr(Elemente,Koordinaten);
  Sigma=evaluate_sigma(U,P1,P2);
  [eta,eta_s]=ZZ_Estimate(Elemente, Koordinaten, Dirichlet, ...
     Neumann, NKV, NNV, Sigma,time);
  
  cd MATRICES
  save(strcat('eta_',num2str(i)),'eta');
  cd ..
  
  if i>=(number_of_refinements-last_uniform_refinements)
     global theta
     thetaold=theta;
     theta=0;
     VK=AAlg1(eta',Elemente,Koordinaten,Kantennr);
     theta=thetaold;
  else
     VK=AAlg1(eta',Elemente,Koordinaten,Kantennr);
  end
  VK = BlauGruen(Elemente,Koordinaten,Kantennr,VK);
  
  % Generiere neue Triangulierung
  trianglesdistribution=howmanytriangles(Elemente,Kantennr,VK);
  [Koordinaten,Elemente,Dirichlet,Neumann]=Verfeinerung(Koordinaten,...
        Elemente,Dirichlet,Neumann,Kantennr,VK);

  if strcmp(problem,'ring')
       Koordinaten=correct_ring_coordinates(Koordinaten,Neumann);
  end
  Prolongation_linear = GeneriereProlongation(Kantennr,VK);
  
  Prolongation_constant=sparse(size(P1prev,1),...
                               size(trianglesdistribution,2));
  index=0;
  for j=1:size(trianglesdistribution,2)
     Prolongation_constant(index+1:index+trianglesdistribution(j),j)=1;
     index=index+trianglesdistribution(j);
  end
  
  cd MATRICES
  save(strcat('Prolongation_linear_',num2str(i)),'Prolongation_linear');
  save(strcat('Prolongation_constant_',num2str(i)),...
              'Prolongation_constant');
  cd ..
           
  U=Prolongation_linear*U;  
  P1prev=Prolongation_constant*P1prev;
  P2prev=Prolongation_constant*P2prev; 
end

mesh_preparation; %gets mesh ready - STEMAelastic + maske and others
incorporate_Dirichlet;
evaluate_fv(time);
evaluate_gv(time);
  
if strcmp(problem,'Lshape')
    for j=1:size(Dirichlet,1)
      U(Dirichlet(j,1),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,1),:));
      U(Dirichlet(j,2),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,2),:));
    end
end
     
disp('Number of elements');
disp(size(Elemente,1));

%enforced uniform refinement
thetaold=theta;
theta=0;
[U_exact,P1_exact,P2_exact]=FEM_Newton_fixed_steps(P1prev,P2prev,U,1);
theta=thetaold;
          
Koordinaten_exact=Koordinaten;
Elemente_exact=Elemente;
     
global STEMAelastic Areaglobal
STEMAelastic_exact=STEMAelastic;
Areaglobal_exact=Areaglobal;
number_of_refinements_exact=number_of_refinements;
Rglobal_exact=Rglobal;

cd MATRICES
save exact_solution U_exact Koordinaten_exact Elemente_exact P1_exact ...
      P2_exact Areaglobal_exact Rglobal_exact number_of_refinements_exact
cd ..
