function [U,U_coarse,P1,P1_coarse,P2,P2_coarse,how_many_iterations_needed]=nested_iteration_error(P1prev,...
   P2prev,U,time,Newtonsteps,eta_criterion)
global STEMAelastic DirichletKnoten freieKnoten maske B W freie2DKnoten ...
   Koordinaten Elemente Neumann Dirichlet %mesh invariants
global fv gv %mesh + time step invariants
global problem

disp('Number of elements');
disp(size(Elemente,1));

incorporate_Dirichlet;
if strcmp(problem,'Lshape')
   for j=1:size(Dirichlet,1)
      U(Dirichlet(j,1),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,1),:));
      U(Dirichlet(j,2),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,2),:));
   end
end
evaluate_fv(time);
evaluate_gv(time);

switch Newtonsteps
   case {'three_stages'}
      [U,P1,P2,how_many_iterations_needed]=FEM_Newton_three_stages(P1prev,P2prev,U);
      disp('Newton step needed for convergence');
      disp(how_many_iterations_needed);
   case {'fixed_residual'}
      [U,P1,P2,how_many_iterations_needed]=FEM_Newton_fixed_residual(P1prev,P2prev,U);
      disp('Newton step needed for convergence');
      disp(how_many_iterations_needed);
   otherwise
      [U,P1,P2]=FEM_Newton_fixed_steps(P1prev,P2prev,U,str2num(Newtonsteps)); 
      how_many_iterations_needed=Newtonsteps;
end
   
if ~isempty(Neumann)
      NKV = Koordinaten(Neumann(:,2),:)- Koordinaten(Neumann(:,1),:);
      NKV = NKV./[sqrt(sum(NKV.*NKV,2)),sqrt(sum(NKV.*NKV,2))]; 
      % Neumann-Kanten % Vektoren, normiert
      NNV = [NKV(:,2),-NKV(:,1)]; % Neumann-Kanten Normalenvektoren
else NKV=[]; NNV=[];
end
   
[Kantennr,Elemente]=GeneriereKantennr(Elemente,Koordinaten);
Sigma=evaluate_sigma(U,P1,P2);
[eta,eta_s]=ZZ_Estimate(Elemente, Koordinaten, Dirichlet, ...
   Neumann, NKV, NNV, Sigma,time);
disp('ZZ-error estimator');
disp(norm(eta));
  
cd MATRICES
save(strcat('eta_',num2str(0)),'eta');
cd ..
  
VK=AAlg1(eta',Elemente,Koordinaten,Kantennr);
VK = BlauGruen(Elemente,Koordinaten,Kantennr,VK);
  
U_coarse=U;
P1_coarse=P1;
P2_coarse=P2;

figure(1);
%show_sigma(U,P1,P2);
show_zones(U,P1,P2);
cd FIGURES
print(gcf,'-depsc',strcat('zones',num2str(1)));
cd ..

while norm(eta) > eta_criterion
% generate mesh refinement
  triangles=howmanytriangles(Elemente,Kantennr,VK);
  [Koordinaten,Elemente,Dirichlet,Neumann]=Verfeinerung(Koordinaten,...
                                Elemente,Dirichlet,Neumann,Kantennr,VK);
  if strcmp(problem,'ring')
       Koordinaten=correct_ring_coordinates(Koordinaten,Neumann);
  end
  
  Prolongation_linear = GeneriereProlongation(Kantennr,VK);
  %generate Prolongation_constant matrix
  Prolongation_constant=sparse(size(P1prev,1),size(triangles,2));
  index=0;
  for j=1:size(triangles,2)
     Prolongation_constant(index+1:index+triangles(j),j)=1;
     index=index+triangles(j);
  end
  
  disp('Number of elements');
  disp(size(Elemente,1));
  
  %Prolongation
  U=Prolongation_linear*U;  
  P1prev=Prolongation_constant*P1prev;
  P2prev=Prolongation_constant*P2prev;  

  mesh_preparation; %gets mesh ready - STEMAelastic + maske and others
  incorporate_Dirichlet;
  if strcmp(problem,'Lshape')
    for j=1:size(Dirichlet,1)
       U(Dirichlet(j,1),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,1),:));
       U(Dirichlet(j,2),:)=Lshape_Dirichlet(Koordinaten(Dirichlet(j,2),:));
    end
  end
  evaluate_fv(time);
  evaluate_gv(time);
  
  switch Newtonsteps
   case {'three_stages'}
      [U,P1,P2,how_many_iterations_needed]=FEM_Newton_three_stages(P1prev,P2prev,U);
      disp('Newton step needed for convergence');
      disp(how_many_iterations_needed);
   case {'fixed_residual'}
      [U,P1,P2,how_many_iterations_needed]=FEM_Newton_fixed_residual(P1prev,P2prev,U);
      disp('Newton step needed for convergence');
      disp(how_many_iterations_needed);
   otherwise
      [U,P1,P2]=FEM_Newton_fixed_steps(P1prev,P2prev,U,str2num(Newtonsteps));  
  end
   
  if ~isempty(Neumann)
      NKV = Koordinaten(Neumann(:,2),:)- Koordinaten(Neumann(:,1),:);
      NKV = NKV./[sqrt(sum(NKV.*NKV,2)),sqrt(sum(NKV.*NKV,2))]; 
      % Neumann-Kanten % Vektoren, normiert
      NNV = [NKV(:,2),-NKV(:,1)]; % Neumann-Kanten Normalenvektoren
  else NKV=[]; NNV=[];
  end
   
  [Kantennr,Elemente]=GeneriereKantennr(Elemente,Koordinaten);
  Sigma=evaluate_sigma(U,P1,P2);
  [eta,eta_s]=ZZ_Estimate(Elemente, Koordinaten, Dirichlet, ...
     Neumann, NKV, NNV, Sigma,time);
  
  disp('ZZ-error estimator');
  disp(norm(eta));
  
  cd MATRICES
  save(strcat('eta_',num2str(i)),'eta');
  cd ..
  
  VK=AAlg1(eta',Elemente,Koordinaten,Kantennr);
  VK = BlauGruen(Elemente,Koordinaten,Kantennr,VK);

  figure(i+1);
  show_zones(U,P1,P2);
  %show_sigma(U,P1,P2);
  cd FIGURES
  print(gcf,'-depsc',strcat('zones',num2str(i+1)));
  cd ..
end
