function [norm_error,norm_eta]=test_adaptive(number_of_refinements,...
   maxNewtonsteps)
global problem yield_type
global last_uniform_refinements;

evaluate_U_coarse
close all

for j=1:maxNewtonsteps
   evaluate_U_exact(number_of_refinements,j);
   cd MATRICES
   load exact_solution;
   cd ..
   
   for k=0:(number_of_refinements-last_uniform_refinements)
      cd MATRICES 
      load(strcat('U_',num2str(k)));
      load(strcat('P1_',num2str(k)));
      load(strcat('P2_',num2str(k)));
      load(strcat('eta_',num2str(k)));
      cd ..
      
      number_of_flops(j,k+1)=flops;
      number_of_unknowns(j,k+1)=size(U,1)*2;
      number_of_elements(j,k+1)=size(P1,1);
      
      for l=k:(number_of_refinements-1)
         cd MATRICES
         load(strcat('Prolongation_linear_',num2str(l)));
         load(strcat('Prolongation_constant_',num2str(l)));
         cd ..
         
         U=Prolongation_linear*U;  
         P1=Prolongation_constant*P1;
         P2=Prolongation_constant*P2;  
      end
      
      error_U=U-U_exact;
      error_P1=P1-P1_exact;
      error_P2=P2-P2_exact;
      
      norm_eta(j,k+1)=norm(eta);
      %mesh_preparation
      norm_error(j,k+1)=NormEnergy(error_U,error_P1,error_P2,...
         Elemente_exact,Koordinaten_exact,...
         Areaglobal_exact,Rglobal_exact);
      
      %normaL2(j,k+1)=NormL2(U,Elemente_exact,Koordinaten_exact);      
   end   
end       

%exact solution for the single-yield ring
if strcmp(yield_type,'single') & strcmp(problem,'ring')
   for k=0:(number_of_refinements-last_uniform_refinements)
      cd MATRICES
      load(strcat('mesh_',num2str(k)));
       cd ..
       Koordinaten=[zeros(size(Koordinaten,1),1) Koordinaten];
       Elemente=[zeros(size(Elemente,1),1) Elemente];
       Dirichlet=[zeros(size(Dirichlet,1),1) Dirichlet];
       Neumann=[zeros(size(Neumann,1),1) Neumann];
       od=cd;
       cd ../JOCHEN_SOLVER  
       save Koordinaten Koordinaten
       save Elemente Elemente
       save Dirichlet Dirichlet
       save Neumann Neumann
       [relTmSpcError,ZZ_Est,Res_Est,SpcError,dof]=...
           fem_plast([0 200],1,10,1e-12,1,1,0,[0])
       cd(od)
       norm_error_exact(k+1)=SpcError;
    end
end
    
%clear Rglobal_exact Prolongation_constant Prolongation_linear
%clear U P1 P2 error_U error_P1 error_P2

if strcmp(yield_type,'single') & strcmp(problem,'ring')
   save matlab norm_eta norm_error norm_error_exact number_of_unknowns
else
   save matlab norm_eta norm_error number_of_unknowns
end

x1=number_of_unknowns(1,:);
y1=norm_error(1,:);
z1=norm_eta(1,:);
x2=number_of_unknowns(2,:);
y2=norm_error(2,:);
z2=norm_eta(2,:);
x3=number_of_unknowns(3,:);
y3=norm_error(3,:);
z3=norm_eta(3,:);
loglog(x1,y1,'-o',x2,y2,'-.o',x3,y3,'--o');
hold on
loglog(x1,z1,'-o',x2,z2,'-.o',x3,z3,'--o');
if strcmp(yield_type,'single') & strcmp(problem,'ring')
   loglog(x3,norm_error_exact,'-d');
end

xlabel('N');
ylabel('\eta_{Z} and error');