function [U,Koordinaten,Elemente,norma,howmanyflops]=test_prolongation(maxNewtonsteps)

load exact_solution;
load coarse_solution;

%setting approximations
U=0*U;
P0=0*P0;
P1=0*P1;

%yield_type='single';

ld=numberofrefinements_exact;

for j=1:maxNewtonsteps
flops(0)
  
load coarse_solution;
U=0*U;
P0=0*P0;
P1=0*P1;
yield_type='single';

mesh_preparation %gets mesh ready - STEMAelastic + maske and others
incorporate_Dirichlet;   
evaluate_fv(t(counter));
evaluate_gv(t(counter));

[U,P0,P1]=FEM_Newton_fixed_steps(P0prev,P1prev,U,j);  
figure(1);
show_zones(U,P0,P1);

cd FIGURES
print(gcf,'-depsc',strcat('zones',num2str(gcf)));
cd ..

U_finest=prolongate_U(U,Elemente,Koordinaten,Dirichlet,Neumann,ld);
error=U_finest-U_exact;
%norma(j,1)=NormaL2(error(:,1),Elemente_exact,Koordinaten_exact)+NormaL2(error(:,2),Elemente_exact,Koordinaten_exact)
norma(j,1)=NormEnergy(error,0*P0_exact,0*P1_exact,STEMAelastic_exact,Areaglobal_exact)
howmanyflops(j,1)=flops
N(1)=size(U,1)*2;

for i=1:ld-1
   
[Kantennr,Elemente]=GeneriereKantennr(Elemente,Koordinaten);
VK = ones(max(max(Kantennr)),1);  %uniforme Verfeinerung
VK = BlauGruen(Elemente,Koordinaten,Kantennr,VK);

% Generiere neue Triangulierung
[Koordinaten,Elemente,Dirichlet,Neumann]=Verfeinerung(Koordinaten,...
                                Elemente,Dirichlet,Neumann,Kantennr,VK);
                             
P = GeneriereProlongation(Kantennr,VK);

U=P*U;
P0prev=[];
P1prev=[];
P0prev(:,:,size(Elemente,1))=zeros(2);
P1prev(:,:,size(Elemente,1))=zeros(2);

%[P0prev_finer]=prolongation(P0prev,Elemente,Koordinaten,Elemente,Koordinaten_finer);
%[P1prev_finer]=prolongation(P1prev_coarser,Elemente_coarser,Koordinaten_coarser,Elemente_finer,Koordinaten_finer);


mesh_preparation %gets mesh ready - STEMAelastic + maske and others
incorporate_Dirichlet;   
evaluate_fv(t(counter));
evaluate_gv(t(counter));

[U,P0,P1]=FEM_Newton_fixed_steps(P0prev,P1prev,U,j);    

U_finest=prolongate_U(U,Elemente,Koordinaten,Dirichlet,Neumann,ld-i);
error=U_finest-U_exact;
howmanyflops(j,i+1)=flops
%norma(j,i+1)=NormaL2(error(:,1),Elemente_exact,Koordinaten_exact)+NormaL2(error(:,2),Elemente_exact,Koordinaten_exact)
norma(j,i+1)=NormEnergy(error,0*P0_exact,0*P1_exact,STEMAelastic_exact,Areaglobal_exact)
 
N(i+1)=size(U,1)*2;

end
end

figure
loglog(N,norma','x-');
legend('1 Newton step','2 Newton steps','3 Newton steps');


cd FIGURES
print(gcf,'-depsc',strcat('error'));
cd ..

figure
loglog(N,howmanyflops','x-');
legend('1 Newton step','2 Newton steps','3 Newton steps');

cd FIGURES
print(gcf,'-depsc',strcat('flops'));
cd ..




