function [U,U_coarse,P0,P0_coarse,P1,P1_coarse]=test_prolongation_starter(P0prev,P1prev,U,time,Newtonsteps,number_of_refinements)
global STEMAelastic DirichletKnoten freieKnoten maske B W freie2DKnoten Koordinaten Elemente Neumann Dirichlet %mesh invariants
global fv gv %mesh + time step invariants
global problem

incorporate_Dirichlet
   
evaluate_fv(time);
evaluate_gv(time);
[U,P0,P1]=FEM_Newton_fixed_steps(P0prev,P1prev,U,Newtonsteps);    
U_coarse=U;
P0_coarse=P0;
P1_coarse=P1;

figure(1);
show_zones(U,P0,P1);
cd FIGURES
print(gcf,'-depsc',strcat('zones',num2str(1)));
cd ..
 
for i=1:number_of_refinements
   [Kantennr,Elemente]=GeneriereKantennr(Elemente,Koordinaten);
   eta = APosterioriZZ(Elemente,Koordinaten,Dirichlet,Neumann,vectorform(U));
   VK=AAlg1(eta',Elemente,Koordinaten,Kantennr);
   VK = BlauGruen(Elemente,Koordinaten,Kantennr,VK);
    
  % Generiere neue Triangulierung
  [Koordinaten,Elemente,Dirichlet,Neumann]=Verfeinerung(Koordinaten,...
                                Elemente,Dirichlet,Neumann,Kantennr,VK);
  P = GeneriereProlongation(Kantennr,VK);

  U=P*U;
  
  P0prev=[];
  P1prev=[];
  P0prev(:,:,size(Elemente,1))=zeros(2);
  P1prev(:,:,size(Elemente,1))=zeros(2);

  mesh_preparation %gets mesh ready - STEMAelastic + maske and others
  
  incorporate_Dirichlet
           
  evaluate_fv(time);
  evaluate_gv(time);

  [U,P0,P1]=FEM_Newton_fixed_steps(P0prev,P1prev,U,Newtonsteps);    

 figure(i+1);
 show_zones(U,P0,P1);
 cd FIGURES
 print(gcf,'-depsc',strcat('zones',num2str(i+1)));
 cd ..
 
end






