 function eta_E=RESIDUAL_Estimate(Koordinaten,Sigma,Neumann,...
                                     t,Kantennr,ElementzuKante)
 %global lambda mu;                                                  
 [I,J]=find(Kantennr);  
 eta_E = zeros(max(max(Kantennr)),1);
 %eta_E_Cnormed = zeros(max(max(Kantennr)),1);
 
 %c = [(2*mu+lambda)/(4*mu*(mu+lambda)),-lambda/(4*mu*(mu+lambda)),1/(2*mu)];
 %% inv. des Elast.-Moduls für plain strain
 %%(eps11, eps12, eps21, esp22)=Cinv(sigma11, sigma12, sigma21, sigma22)
 %Cinv = [c(1) 0 0 c(2); 0 c(3) 0 0; 0 0 c(3) 0; c(2) 0 0 c(1)]; 

 for j=1:size(I,1)
     node1=I(j);
     node2=J(j);
     %edge number shared by nodes node1 and node2
     noed=Kantennr(node1,node2);
     %elements sharing this edge, elem2 is zero for the edge on boundary!  
     elem1=ElementzuKante(node1,node2);
     elem2=ElementzuKante(node2,node1);
     
     vector=Koordinaten(node2,:) - Koordinaten(node1,:);
     %normal vector point outside
     normal=[vector(2) -vector(1)];
     h_E=norm(normal);
     
     normal_unit=normal/h_E;
    
     %the edge is not a boundary edge
     if (elem2~=0)
        SigmaDifer=Sigma(elem1,:)-Sigma(elem2,:);
        J_E=normal_unit*[SigmaDifer(1) SigmaDifer(3); ... 
                    SigmaDifer(3) SigmaDifer(2)];
     else
        [indx1,temp]=find(Neumann==node1);
        [indx2,temp]=find(Neumann==node2);
        indexNeumann=intersect(indx1,indx2);
        if (isempty(indexNeumann))
            %the edge belongs to the Dirichlet boundary
            J_E=[0 0];
        else
            %the edge belongs to the Neumann boundary
            centerpoint=(Koordinaten(Neumann(indexNeumann,1),:)+...
                         Koordinaten(Neumann(indexNeumann,2),:))/2;
            J_E=normal_unit*[Sigma(elem1,1) Sigma(elem1,3); ... 
                        Sigma(elem1,3) Sigma(elem1,2)] ...
                 -g(centerpoint, normal_unit, t);
        end
     end
     eta_E(noed)=sum(J_E.^2)*h_E^2;
     %eta_E_Cnormed(noed)=sum(J_E.^2)*h_E^2;
 end
 eta_E = sqrt(eta_E);
 
    



