% uniforme Rotverfeinerung
%
%
function [Koordinaten,Elemente,Dirichlet,Neumann] = ...
       Rotverfeinerung(Koordinaten,Elemente,Dirichlet,Neumann)
% Initialisiere

 succ = [2,3,1]; 
 K = sparse(size(Koordinaten,1),size(Koordinaten,1));

% Schleife ueber alle Elemente

 for ielem = 1:size(Elemente,1)
   knoten(1:3) = Elemente(ielem,1:3);
   for i = 1:3
     imin = min([Elemente(ielem,i),Elemente(ielem,succ(i))]);
     imax = max([Elemente(ielem,i),Elemente(ielem,succ(i))]);

% neuen Knoten erzeugen ?

     if (K(imin,imax)==0) 

% erzeuge einen neuen Knoten

       knoten(3+i) = size(Koordinaten,1)+1 ;
       Koordinaten(size(Koordinaten,1)+1,:) = ...
              [(Koordinaten(imin,1)+Koordinaten(imax,1))/2, ...
               (Koordinaten(imin,2)+Koordinaten(imax,2))/2] ;
       K(imin,imax) = size(Koordinaten,1);

% der gesuchte Knoten existiert schon

     else
       knoten(3+i) = K(imin,imax) ;
     end
   end

% Update von Elemente

   Elemente(ielem,:) =  knoten([4,5,6]); 
   Elemente(size(Elemente,1)+1,:) =  knoten([1,4,6]);
   Elemente(size(Elemente,1)+1,:) =  knoten([4,2,5]); 
   Elemente(size(Elemente,1)+1,:) =  knoten([5,3,6]); 
 end

% Update von Neumann
if ~isempty(Neumann)
 for ineu = 1:size(Neumann,1)
   knoten(1) = K(min([Neumann(ineu,1),Neumann(ineu,2)]),...
                 max([Neumann(ineu,1),Neumann(ineu,2)]));
   knoten(2) = Neumann(ineu,2);  
   Neumann(ineu,2) = knoten(1);
   Neumann(size(Neumann,1)+1,1:2) = knoten(1:2);
 end
end
% Update von Dirichlet
if ~isempty(Dirichlet)
 for idir = 1:size(Dirichlet,1)
   knoten(1) = K(min([Dirichlet(idir,1),Dirichlet(idir,2)]),...
                 max([Dirichlet(idir,1),Dirichlet(idir,2)]));
   knoten(2) = Dirichlet(idir,2);  
   Dirichlet(idir,2) = knoten(1);
   Dirichlet(size(Dirichlet,1)+1,1:2) = knoten(1:2);
 end
end
