function [Koordinaten,NeueElemente,Dirichlet,Neumann]=...
                  Verfeinerung(Koordinaten,Elemente,Dirichlet,Neumann,...
                               Kantennr,VK)
                                
[VK1 VK2 VK3]=find(VK);                       
                               
%New array created, it returns two nodes belonging to a given edge
nKanten=max(max(Kantennr));
NodenzuKante=zeros(nKanten,2);
[a,b]=find(Kantennr);
for j=1:nnz(Kantennr);
    NodenzuKante(Kantennr(a(j),b(j)),:)=[a(j) b(j)];
end

%VK;

% Koordinaten anpassen
 K=find(VK);
 for j=1:nnz(VK)
     
     Koordinaten(VK(K(j)),:)=(Koordinaten(NodenzuKante(K(j),1),:) ...
                             +Koordinaten(NodenzuKante(K(j),2),:))/2;    
 end
 
% Elemente anpassen 
 Aussenkanten=nonzeros(tril(abs(Kantennr-Kantennr')));
 NeueElemente=zeros(2*nnz(VK)-nnz(VK(Aussenkanten))+size(Elemente,1),3);
 ell=0; 
 
 for j=1:size(Elemente,1)
   %old, working, slow
   %I = diag(Kantennr(Elemente(j,:),Elemente(j,[2 3 1])))';
   %RefineEdge=find(VK(I));
   %NeuKnoten=VK(I(RefineEdge))';
   
   %new, faster, also working
   I = full(diag(Kantennr(Elemente(j,:),Elemente(j,[2 3 1]))));
   [value, iI, iVK1]=intersect(VK1,I);
   [value, iI, iVK1]=intersect(I,VK1);
   %RefineEdge2=iI
   [RefineEdge, sorted]=sort(iI);
   NeuKnoten=sparse(VK3(iVK1)');
   NeuKnoten=NeuKnoten(sorted);
   
   
   
   if size(RefineEdge,1)==3
      locNeueElemente=[NeuKnoten([2 3 1]); 
                     [Elemente(j,1) NeuKnoten(1) NeuKnoten(3)]; 
                     [NeuKnoten(1) Elemente(j,2) NeuKnoten(2)];
                     [NeuKnoten(3) NeuKnoten(2) Elemente(j,3)]];
   elseif size(RefineEdge,1)==2
      locNeueElemente=...
        [[NeuKnoten(1), Elemente(j,RefineEdge(2)),NeuKnoten(2)];
        [Elemente(j,5-RefineEdge(2)),Elemente(j,rem(5-RefineEdge(2),3)+1),...
                                                          NeuKnoten(1)];
        [Elemente(j,rem(RefineEdge(2),3)+1),NeuKnoten(1),NeuKnoten(2)]];
  elseif size(RefineEdge,1)==1
      locNeueElemente=[[Elemente(j,[2 3]),NeuKnoten];
                     [Elemente(j,[3 1]),NeuKnoten]];
     else
       locNeueElemente=Elemente(j,:);
   end
   NeueElemente(ell+1:ell+size(locNeueElemente,1),:)=locNeueElemente;
   ell=ell+size(locNeueElemente,1);
 end
 
% Dirichlet und Neumann anpassen
 tmp=0;
 Dirichletnr=diag(Kantennr(Dirichlet(:,1),Dirichlet(:,2)));
 for k=1:size(Dirichlet,1)
   if VK(Dirichletnr(k))
     Dirichlet=[Dirichlet(1:k-1+tmp,:);Dirichlet(k+tmp,1),VK(Dirichletnr(k));
               VK(Dirichletnr(k)),Dirichlet(k+tmp,2);
               Dirichlet(k+1+tmp:size(Dirichlet,1),:)];
     tmp=tmp+1;
   end
 end
 tmp=0;
 if ~isempty(Neumann)
   Neumannnr=diag(Kantennr(Neumann(:,1),Neumann(:,2)));
 end
 for k=1:size(Neumann,1)
   if VK(Neumannnr(k))
     Neumann = [Neumann(1:k-1+tmp,:);Neumann(k+tmp,1),VK(Neumannnr(k));
               VK(Neumannnr(k)),Neumann(k+tmp,2);
               Neumann(k+1+tmp:size(Neumann,1),:)];
     tmp=tmp+1;
   end
 end
 
