magic=1000

cd CONVERGENCE/COOK/RESIDUAL
load uniform
N_uniform=N;
E_uniform=ErrorEstimator/magic;

load adaptive_new
N_alg71=N;
E_alg71=ErrorEstimator/magic;

load adaptive
N_alg72=N;
E_alg72=ErrorEstimator/magic;
cd ../../..

figure(9)
loglog(N_uniform,E_uniform,'k-o',N_alg71,E_alg71,'b-s',N_alg72,E_alg72,'r-v');
xlabel('Degrees of freedom, N');
ylabel('\eta');

legend('Uniform refinement', ...
       'AFEM based on bulk criterion (Alg7.1)',...
       'AFEM based on max refinement rule (Alg7.2)');

line([10^4 10^4 10^5 10^4],[10^(-1.25) 10^(-1.75) 10^(-1.75) 10^(-1.25)]); %lower triangle
text(10^(4.5),10^(-1.82),'1');
text(10^(3.75),10^(-1.5),'0.5');
 
line([10^4 10^5 10^5 10^4],[10^(-0.8) 10^(-1.1) 10^(-0.8) 10^(-0.8)]); %upper triangle
text(10^(4.5),10^(-0.77),'1');
text(10^(5.1),10^(-0.98),'0.3');

print -depsc error_vs_dofs

figure(10)
semilogy(1:size(E_alg71,1),E_alg71,'b-s',1:size(E_alg72,1),E_alg72,'r-v');
xlabel('Number of refinements loops');
ylabel('\eta');

legend('AFEM based on bulk criterion (Alg7.1)',...
       'AFEM based on max refinement rule (Alg7.2)');
print -depsc error_vs_refinements
