cd CONVERGENCE/PLATEHOLE/RESIDUAL
load uniform
N_uniform=N;
E_uniform=ErrorEstimator;

load adaptive_new
N_alg71=N;
E_alg71=ErrorEstimator;

load adaptive
N_alg72=N;
E_alg72=ErrorEstimator;
cd ../../..

figure(9)
loglog(N_uniform,E_uniform,'-o',N_alg71,E_alg71,'-s',N_alg72,E_alg72,'v');
title('Strip with the hole')
xlabel('degrees of freedom N');
ylabel('residual-error estimator');

legend('uniform refinement', ...
       'adaptive refinement using Alg7.1 ',...
       'adaptive refinement using Alg7.2 ');
       
%AXIS([3e1 7e5 1e2 3e4])
line([5e3 5e5 5e3 5e3],[2e2 2e2 2e3 2e2])

ratio_alg71=[];
for i=1:size(E_alg71,1)-1
    ratio_alg71=[ratio_alg71 E_alg71(i+1)/E_alg71(i)];
end
ratio_alg71

save conv_platehole N_uniform N_alg71 N_alg72 E_uniform E_alg71 E_alg72 ratio_alg71
print -depsc conv_platehole  

figure(10)
semilogy(1:size(E_uniform,1),E_uniform,'-o',1:size(E_alg71,1),E_alg71,'-s',1:size(E_alg72,1),E_alg72,'-v');
title('Strip with the hole')
xlabel('number of mesh-refinements');
ylabel('residual-error estimator');

legend('uniform refinement', ...
       'adaptive refinement using Alg7.1 ',...
       'adaptive refinement using Alg7.2 ');
print -depsc conv2_platehole  

cd CONVERGENCE/PLATEHOLE/ZZ
%load uniform
%N_uniform=N;
%E_uniform=ErrorEstimator;

load adaptive_new
N_alg71=N;
E_alg71=ErrorEstimator;

load adaptive
N_alg72=N;
E_alg72=ErrorEstimator;
cd ../../..

figure(11)
loglog(N_alg71,E_alg71,'-s',N_alg72,E_alg72,'-v');
title('Strip with the hole')
xlabel('degrees of freedom N');
ylabel('ZZ-error estimator');

legend('adaptive refinement using Alg7.1 ',...
       'adaptive refinement using Alg7.2 ');

figure(12)
semilogy(1:size(E_alg71,1),E_alg71,'-s',1:size(E_alg72,1),E_alg72,'-v');
title('Strip with the hole')
xlabel('number of mesh-refinements');
ylabel('ZZ-error estimator');

legend('adaptive refinement using Alg7.1 ',...
       'adaptive refinement using Alg7.2 ');





