function DPhi=evaluate_DPhi_plastic(U,P1prev,P2prev,plasticelements)
global STEMAelastic 
global C Koordinaten Elemente mu h1 h2 sigmay1 sigmay2 yield_type tolerance
global P1locallast P2locallast
global plasticstiffnessmatrix

DPhi=STEMAelastic;

if strcmp(plasticstiffnessmatrix,'yes')
    mu_times_2=2*mu;
    for j=1:size(Elemente,1);
        if plasticelements(j)>0
            %assignment of real indices
            I=2*Elemente(j,[1 1 2 2 3 3])-[1,0,1,0,1,0];
      
            P1prevlocal=P1prev(j,:)';
            P2prevlocal=P2prev(j,:)';
            Elementelocal=Elemente(j,:);
            Koordinatenlocal=Koordinaten(Elementelocal,:);
            Rlocal=R(Koordinatenlocal);
            Arealocal=det([1 1 1;Koordinatenlocal'])/2;
            Ulocal=U(Elementelocal,:);
      
            for i=1:6
                Uvectorlocal=vectorform(Ulocal);
                %setting up the increment for the approximation of DPhi
                epsilon=sqrt(eps)*max(1,abs(Uvectorlocal(i)));

                Upluslocal=Uvectorlocal; 
                Upluslocal(i)=Upluslocal(i)+epsilon;
                Upluslocal=matrix2form(Upluslocal);
                Ulocalvector([1 3 5],1)=Upluslocal(:,1);
                Ulocalvector([2 4 6],1)=Upluslocal(:,2);
         
                gamma=Rlocal*Ulocalvector; 
                sigmaelasticlocal=C*gamma;
         
                if strcmp(yield_type,'single')
                    [P1pluslocal]=evaluate_P_local_single(sigmaelasticlocal,...
                                 P1prevlocal,mu_times_2, h1,sigmay1);
                    P2pluslocal=zeros(size(P1pluslocal,1),1);
                else
                    P2prevlocal=P2prev(j,:)';
                    [P1pluslocal,P2pluslocal]=evaluate_P_local_multi(sigmaelasticlocal,...
                                               P1prevlocal,P2prevlocal, ...
                                               mu_times_2, h1, h2, ...
                                               sigmay1, sigmay2, tolerance, ...
                                               P1locallast,P2locallast);   
                end

                Uminuslocal=Uvectorlocal;
                Uminuslocal(i)=Uminuslocal(i)-epsilon;
                Uminuslocal=matrix2form(Uminuslocal);
                Ulocalvector([1 3 5])=Uminuslocal(:,1);
                Ulocalvector([2 4 6])=Uminuslocal(:,2);
                gamma=Rlocal*Ulocalvector; 
                sigmaelasticlocal=C*gamma;
         
                if strcmp(yield_type,'single')
                    [P1minuslocal]=evaluate_P_local_single(sigmaelasticlocal,...
                                 P1prevlocal,mu_times_2, h1,sigmay1);
                    P2minuslocal=zeros(size(P1minuslocal,1),1);          
                else
                    [P1minuslocal,P2minuslocal]=evaluate_P_local_multi(sigmaelasticlocal,...
                                               P1prevlocal,P2prevlocal, ...
                                               mu_times_2, h1, h2, ...
                                               sigmay1, sigmay2, tolerance, ...
                                               P1locallast,P2locallast);                  
                end

         
                %approximation of the derivation by the difference
                
                
                
                STEMA3Plastic(i,:)=integral_plastic(Rlocal,Arealocal,...
                (P1pluslocal+P2pluslocal-P1minuslocal-P2minuslocal)/2/epsilon);
            end
            DPhi(I,I)=DPhi(I,I)-STEMA3Plastic';
        end
    end
end

