function [W,M] = u_D(locKoordinaten)
global problem
M = zeros(2*size(locKoordinaten,1),2);
W = zeros(2*size(locKoordinaten,1),1);

switch problem
      case 'beam1D',
         temp = find(locKoordinaten(:,1)==0);
         M(2*temp-1,1:2) = ones(size(temp,1),1)*[1 0];
         temp = find(locKoordinaten(:,2)==0); 
         M(2*temp,1:2) = ones(size(temp,1),1)*[0 1];
      case {'beam2D','cook'}
         temp = find(locKoordinaten(:,1)==0);
         M(2*temp-1,1:2) = ones(size(temp,1),1)*[1 0];
         M(2*temp,1:2) = ones(size(temp,1),1)*[0 1];
      case {'ring','platehole'},
         temp = find(locKoordinaten(:,1)==0);
         M(2*temp-1,1:2) = ones(size(temp,1),1)*[1 0];
         temp = find(locKoordinaten(:,2)==0); 
         M(2*temp,1:2) = ones(size(temp,1),1)*[0 1];
      case 'Lshape',
         temp1 = find(abs(locKoordinaten(:,1)-locKoordinaten(:,2))==2);
         temp2 = find(abs(locKoordinaten(:,2)+locKoordinaten(:,1))==2);
         temp3a = find(locKoordinaten(:,1)-locKoordinaten(:,2)==0);
         temp3b=  find(locKoordinaten(:,1)<=0);
         temp3=intersect(temp3a,temp3b);
         temp4a = find(locKoordinaten(:,1)+locKoordinaten(:,2)==0);
         temp4b=  find(locKoordinaten(:,1)<=0);
         temp4=intersect(temp4a,temp4b);
         temp=union(temp1,temp2);temp=union(temp,temp3);temp=union(temp,temp4);
         M(2*temp-1,1:2) = ones(size(temp,1),1)*[1 0];
         M(2*temp,1:2) = ones(size(temp,1),1)*[0 1];
         %alpha=0.544483737;
         %C1=-(cos((alpha+1)*3*pi/4))/(cos((alpha-1)*3*pi/4));
         %global lambda mu
         %C2=(2*(lambda+2*mu))/(lambda+mu);
         %for i=1:size(temp,1);
         %   x=locKoordinaten(temp(i),1);
         %   y=locKoordinaten(temp(i),2);
         %end
     case 'Lshape_new',
         temp = find(locKoordinaten(:,2)==-2);
         M(2*temp-1,1:2) = ones(size(temp,1),1)*[1 0];
         M(2*temp,1:2) = ones(size(temp,1),1)*[0 1];
end
